const STATE_START = Components.interfaces.nsIWebProgressListener.STATE_START;
const STATE_STOP = Components.interfaces.nsIWebProgressListener.STATE_STOP;
var reencodingListener = {
  
 stopIsValid: new Boolean(false),
  
  QueryInterface: function(aIID) {
   if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
       aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
       aIID.equals(Components.interfaces.nsISupports))
     return this;
   throw Components.results.NS_NOINTERFACE;
  },

  onStateChange: function(aProgress, aRequest, aFlag, aStatus) {
   if(aFlag & STATE_START) {
		     // This fires when the load event is initiated
     this.reencoding(aRequest);
     stopIsValid = true;
   }
   if(aFlag & STATE_STOP) {
     // This fires when the load finishes
     if(stopIsValid){
       stopIsValid = false;
     }  
   }
   return 0;
  },

  onLocationChange: function(aProgress, aRequest, aURI) {
     return 0;
  },

  // For definitions of the remaining functions see XulPlanet.com
  onProgressChange: function() {return 0;},
  onStatusChange: function() { return 0;},
  onSecurityChange: function() {return 0;},
  onLinkIconAvailable: function() {return 0;},
  reencoding:function(aRequest){
	  var elements=encodingLockStorage.getContainerElements();
			     var matched=false;
			     var charset=null;
			     while (elements.hasMoreElements()){
				  	var element = elements.getNext();
				  	var urlPattern=encodingLockStorage.getUrlPattern(element);
	//			  	alert('before conversion: '+urlPattern);
				     var regUrlPattern=convert2RegExp(urlPattern);
	//   			  	alert('after conversion: '+regUrlPattern);
					     if(regUrlPattern.test(aRequest.name)){
				     	matched=true;
				     	charset=encodingLockStorage.getEncoding(element);
	//			     	alert('matching url pattern found');
					    break;
				     }				  	
				 } 
			    var frameNav = document.commandDispatcher.focusedWindow.QueryInterface(Components.interfaces.nsIInterfaceRequestor).getInterface(Components.interfaces.nsIWebNavigation);
			    if(matched){
				    frameNav.QueryInterface(Components.interfaces.nsIDocShell).QueryInterface(Components.interfaces.nsIDocCharset).charset = charset; 
//				    alert('render page with '+charset);
			    }
	}
}
//register a listener to reencode the matched url
function encodingLockInit(){
	gBrowser.addProgressListener(reencodingListener,Components.interfaces.nsIWebProgress.NOTIFY_STATE_DOCUMENT);
	return true;
}
