var encodingLockStorage={
	RDF : Components.classes["@mozilla.org/rdf/rdf-service;1"]
        .getService(Components.interfaces.nsIRDFService),
    RDFCUtils : Components.classes["@mozilla.org/rdf/container-utils;1"]
              .getService()
              .QueryInterface(Components.interfaces.nsIRDFContainerUtils),
    NS : "http://encodinglock.mozdev.org/el#",
    mappingDS:null,
    saveUrlMapping: function(urlPattern,encoding){
    	 var urlMappingDS=this.getMappingDS();
    	 var elements = urlMappingDS.GetAllResources();
    	 var container=null;
      	while (elements.hasMoreElements()) {
        	var el = elements.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
        	if(this.RDFCUtils.IsSeq(urlMappingDS, el)) {
        		container=this.newContainer();
        		container.Init(urlMappingDS,el);
		    	 var node = this.RDF.GetAnonymousResource();    
		    	 container.AppendElement(node, true);
        	}
        }
   		 this.assertLiteral(urlMappingDS, node, "urlpattern", urlPattern);
  		 this.assertLiteral(urlMappingDS, node, "encoding", encoding);
  		 urlMappingDS.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource).Flush();
    },
     changeUrlMapping: function(uri,urlPattern,encoding){
    	 var urlMappingDS=this.getMappingDS();
    	 var mappingResource=this.RDF.GetResource(uri);
    	 var urlPatternProperty=this.RDF.GetResource(this.NS+'urlpattern');
    	 var encodingProperty=this.RDF.GetResource(this.NS+'encoding');
    	 var oldUrlPattern=urlMappingDS.GetTarget(mappingResource,urlPatternProperty,true);
    	 oldUrlPattern= oldUrlPattern.QueryInterface(Components.interfaces.nsIRDFLiteral);
		 urlMappingDS.Change(mappingResource,urlPatternProperty,oldUrlPattern,this.RDF.GetLiteral(urlPattern));
    	 var oldEncoding=urlMappingDS.GetTarget(mappingResource,encodingProperty,true);
		 urlMappingDS.Change(mappingResource,encodingProperty,oldEncoding,this.RDF.GetLiteral(encoding));
  		 urlMappingDS.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource).Flush();
    },
    removeUrlMapping:function(uri,urlPattern,encoding){
    	var urlMappingDS=this.getMappingDS();
    	 var mappingResource=this.RDF.GetResource(uri);
    	 var urlPatternProperty=this.RDF.GetResource(this.NS+'urlpattern');
    	 var encodingProperty=this.RDF.GetResource(this.NS+'encoding');
    	  urlMappingDS.Unassert(mappingResource,urlPatternProperty,this.RDF.GetLiteral(urlPattern));
    	 urlMappingDS.Unassert(mappingResource,encodingProperty,this.RDF.GetLiteral(encoding));
    	 
    	 var elements = urlMappingDS.GetAllResources();
    	 var container=null;
      	while (elements.hasMoreElements()) {
        	var el = elements.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
        	if(this.RDFCUtils.IsSeq(urlMappingDS, el)) {
        		container=this.newContainer();
        		container.Init(urlMappingDS,el);		    	
		    	 container.RemoveElement(mappingResource, true);
        	}
        }
  		 urlMappingDS.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource).Flush();
    },
    getContainerElements:function(){
    	var urlMappingDS=this.getMappingDS();
    	var elements = urlMappingDS.GetAllResources();
    	 var container=null;
      	while (elements.hasMoreElements()) {
        	var el = elements.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
        	if(this.RDFCUtils.IsSeq(urlMappingDS, el)) {
        		container=this.newContainer();
        		container.Init(urlMappingDS,el);		    	
        		return container.GetElements();
        	}
        }
        return null;
    },
    getUrlPattern:function(element){
    	var urlMappingDS=this.getMappingDS();
    	var urlPatternProperty=this.RDF.GetResource(this.NS+'urlpattern');
    	var urlPattern=urlMappingDS.GetTarget(element,urlPatternProperty,true);
    	 urlPattern= urlPattern.QueryInterface(Components.interfaces.nsIRDFLiteral);
    	 return urlPattern.Value;
    },
    getEncoding:function(element){
    	var urlMappingDS=this.getMappingDS();
    	var encodingProperty=this.RDF.GetResource(this.NS+'encoding');
    	var encoding=urlMappingDS.GetTarget(element,encodingProperty,true);
    	 encoding= encoding.QueryInterface(Components.interfaces.nsIRDFLiteral);
    	 return encoding.Value;
    },
   newContainer : function() {
    return Components.classes['@mozilla.org/rdf/container;1'].createInstance()
           .QueryInterface(Components.interfaces.nsIRDFContainer);
  },
     getMappingDS : function() {
    if (this.mappingDS) {
      return this.mappingDS;
    } else {
    var mappingFile = this.getProfileDirectory();
      mappingFile.append("encodingMapping.rdf");
      this.mappingDS = this.RDF.GetDataSourceBlocking(this.fileToURL(mappingFile).spec);
      var seqElement=this.RDF.GetResource('el:mappinglist');
      this.RDFCUtils.MakeSeq(this.mappingDS,seqElement);
      this.mappingDS.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource).Flush();
      return this.mappingDS;
    }
  },
    assertLiteral : function(dsource, node, propName, value) {
    dsource.Assert(node, this.RDF.GetResource(this.NS + propName),
                   this.RDF.GetLiteral(value), true);
  },
  getSource:function(dataSource,property,object){
  	return dataSource.getSource(this.RDF.GetResource(this.NS + property),this.RDF.GetLiteral(object),true);
  },
  /*** profile & URL handling ***/
  /*
  getExtensionDir : function() {
    const extensionId = "encodinglock@mozdev.org";
	var ext = Components.classes["@mozilla.org/extensions/manager;1"]
                    .getService(Components.interfaces.nsIExtensionManager)
                    .getInstallLocation(extensionId)
                    .getItemLocation(extensionId);
     var file = Components.classes["@mozilla.org/file/local;1"]
                     .createInstance(Components.interfaces.nsILocalFile);
	file.initWithPath(ext.path+"/content");
    return file;
  },
  */
  getProfileDirectory:function(){
      // get a File representing user's profile dir
  	var file = Components.classes["@mozilla.org/file/directory_service;1"]
                     .getService(Components.interfaces.nsIProperties)
                     .get("ProfD", Components.interfaces.nsIFile);
    return file;
  },
  fileToURL : function(aFile) {
    var fileHandler = Components.classes["@mozilla.org/network/io-service;1"]
                        .getService(Components.interfaces.nsIIOService);
    return fileHandler.newFileURI(aFile);
  }
}